from __future__ import unicode_literals

from django.apps import apps

from evotevotings.voters.importers import ElectoralRollImporter
from celery.utils.log import get_task_logger
from evote.celery import app


logger = get_task_logger(__name__)


@app.task(ignore_result=True)
def import_electoral_roll(electoral_roll_id):
    """ """
    ElectoralRoll = apps.get_model("evotevoters.ElectoralRoll")  # noqa
    electoral_roll = ElectoralRoll.objects.select_related('election')\
        .get(pk=electoral_roll_id)
    try:
        importer = ElectoralRollImporter()
        importer.run(electoral_roll, electoral_roll.document.document)
    except Exception:
        logger.exception("Error importing electoral roll")
    finally:
        electoral_roll.imported = True
        electoral_roll.save()
